﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			// serial port öffnen
			this.serialPort1.Open();
		}

		private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
		{
			// Daten auslesen und zwischen speichern...
			var data = this.serialPort1.ReadExisting();

			// trace vorbereiten und ausgeben...
			var dt = DateTime.Now;
			System.Diagnostics.Debug.WriteLine(string.Format("DataReceived: {0}:{1} EventType:{3} Data:'{2}'", dt.ToLongTimeString(), dt.Millisecond, data, e.EventType));

			// POST an den MainThread um die RichText Box zu befüllen!
			// POST (BeginInvoke) und nicht SEND (Invoke) um den SerialPort nicht unnötig aufzuhalten!!)			
			this.BeginInvoke((Action)delegate() {
				this.richTextBox1.Text += data; });
		}

		private void Form1_FormClosing(object sender, FormClosingEventArgs e)
		{
			// serial port zu machen
			this.serialPort1.Close();
		}
	}
}
